package io.accumulatenetwork.sdk.generated.apiv2;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import io.accumulatenetwork.sdk.protocol.RPCBody;
import io.accumulatenetwork.sdk.support.serializers.HexDeserializer;
import io.accumulatenetwork.sdk.support.serializers.HexSerializer;
// UnionType: 
// UnionValue: 

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("ChainIdQuery")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class ChainIdQuery implements RPCBody {
	private byte[] chainId;

    //
	@JsonDeserialize(using = HexDeserializer.class)
	public byte[] getChainId() {
	    return chainId;
	}
	@JsonSerialize(using = HexSerializer.class)
	public void setChainId(final byte[] value) {
	    this.chainId = value;
	}

	public ChainIdQuery chainId(final byte[] value) {
	    setChainId(value);
	    return this;
	}
	public ChainIdQuery chainId(final String value) {
		try {
			setChainId(io.accumulatenetwork.sdk.commons.codec.binary.Hex.decodeHex(value));
		} catch (io.accumulatenetwork.sdk.commons.codec.DecoderException e) {
			throw new RuntimeException(e);
		}
	    return this;
	}
}
